public	class	Dato
{
		private	int	datoen;

		public				Dato	()
		{
				this.datoen = 19800101; /* default constructor - ekstra */
		}
		public				Dato	(int initAar, int initMaaned, int initDag)
		{
				this.datoen = (initAar*10000) + (initMaaned*100) + initDag;
		}
		public	void	setMaaned	(int nyMaaned)
		{
				this.datoen =	((this.datoen/10000)*10000) +
											(nyMaaned*100) + (this.datoen%100);
		}
		public	int	getMaaned	( )
		{
				return	((this.datoen/100)%100);
		}
		public	void	setAar	(int nyAar)
		{
				this.datoen =	(nyAar*10000) + (this.datoen%10000);
		}
		public	int	getAar	( )
		{
				return	(this.datoen/10000);
		}
		public	void	setDag	(int nyDag)
		{
				this.datoen =	((this.datoen/100)*100) + nyDag;
		}
		public	int	getDag	( )
		{
				return	(this.datoen%100);
		}
		public	String	getDatoStringAMD	( )
		{
				return ( new String (	this.getAar()+"-"+
															this.getMaaned()+"-"+this.getDag() ) );
		}
		public	String	getDatoStringDMA	( )
		{
				return ( new String	(	this.getDag()+"/"+this.getMaaned()+"/"+
													 		(this.getAar()%100) ) );
		}

		public	String	getDatoStringAMDMedForanstilletNuller	( )
		{
				if ((getMaaned( ) < 10) && (getDag() < 10))
						return ( new String (	this.getAar()+"-0"+
																	this.getMaaned()+"-0"+this.getDag() ) );
				else if (getMaaned( ) < 10)
						return ( new String (	this.getAar()+"-0"+
																	this.getMaaned()+"-"+this.getDag() ) );
				else if (getDag( ) < 10)
						return ( new String (	this.getAar()+"-"+
																	this.getMaaned()+"-0"+this.getDag() ) );
				else
						return ( new String (	this.getAar()+"-"+
																	this.getMaaned()+"-"+this.getDag() ) );
		}
		/* Alternative metoder som udnytter de
			 tidligere definede get-funktioner		*/
		public	void	setMaanedAlternativ	(int nyMaaned)
		{
				this.datoen =	(this.getAar()*10000) +
											(nyMaaned*100) + this.getDag();
		}
		public	void	setAarAlternativ	(int nyAar)
		{
				this.datoen =	(nyAar*10000) +
											(this.getMaaned()*100) + this.getDag();
		}
		public	void	setDagAlternativ	(int nyDag)
		{
				this.datoen =	(this.getAar()*10000) +
											(this.getMaaned()*100) + nyDag;
		}


		public	int	getKvartal()
		{
				int kvartal;											// Hjlpe-variabel
				if (this.getMaaned() <= 3)				// Kvartalet "udregnes"
				 		kvartal = 1;									// ud fra den mned
				else if (this.getMaaned() <= 6)		// der er tildelt
				 		kvartal = 2;									// til objektet
				else if (this.getMaaned() <= 9)
			 			kvartal = 3;
				else
				 		kvartal = 4;
			 	return (kvartal);
		}

		public	int	getKvartalAlternativ1()		// med switch
		{
				int kvartal;
				switch (this.getMaaned())
				{
						case 1:
						case 2:
						case 3:	kvartal = 1;
										break;

						case 4:
						case 5:
						case 6:	kvartal = 2;
										break;
						
						case 7:
						case 8:
						case 9:	kvartal = 3; 
										break;
						
						default:kvartal = 4;
				}
			 	return (kvartal);
		}

		public	int	getKvartalAlternativ2() 	// som beregning
		{																		// uden hjlpevariabel
			 	return ( ((this.getMaaned()-1)/3) + 1 );
		}

		public	String	getMaanedTxt()		// med switch
		{
				String maanedTxt;
				switch (this.getMaaned())
				{
						case  1:	maanedTxt = new String ("Januar");
											break;
						case  2:	maanedTxt = new String ("Februar");
											break;
						case  3:	maanedTxt = new String ("Marts");
											break;
						case  4:	maanedTxt = new String ("April");
											break;
						case  5:	maanedTxt = new String ("Maj");
											break;
						case  6:	maanedTxt = new String ("Juni");
											break;
						case  7:	maanedTxt = new String ("Juli");
											break;
						case  8:	maanedTxt = new String ("August");
											break;
						case  9:	maanedTxt = new String ("September");
											break;
						case 10:	maanedTxt = new String ("Oktober");
											break;
						case 11:	maanedTxt = new String ("November");
											break;
						case 12:	maanedTxt = new String ("December");
											break;
						default:	maanedTxt = new String ("Fejl mned");
				}
			 	return (maanedTxt);
		}

		public	String	getMaanedTxtAlternativ()		// med if-else
		{
				String maanedTxt;
				if (this.getMaaned() == 1)
						maanedTxt = new String ("Januar");
				else if (this.getMaaned() == 2)
						maanedTxt = new String ("Februar");
				else if (this.getMaaned() == 3)
						maanedTxt = new String ("Marts");
				else if (this.getMaaned() == 4)
						maanedTxt = new String ("April");
				else if (this.getMaaned() == 5)
						maanedTxt = new String ("Maj");
				else if (this.getMaaned() == 6)
						maanedTxt = new String ("Juni");
				else if (this.getMaaned() == 7)
						maanedTxt = new String ("Juli");
				else if (this.getMaaned() == 8)
						maanedTxt = new String ("August");
				else if (this.getMaaned() == 9)
						maanedTxt = new String ("September");
				else if (this.getMaaned() == 10)
						maanedTxt = new String ("Oktober");
				else if (this.getMaaned() == 11)
						maanedTxt = new String ("November");
				else if (this.getMaaned() == 12)
						maanedTxt = new String ("December");
				else
						maanedTxt = new String ("Fejl mned");
			 	return (maanedTxt);
		}

		public	String	getKvartalTxt()		// med switch
		{
				String kvartalTxt;
				switch (this.getKvartal())
				{
						case  1:	kvartalTxt = new String ("Januar kvartal");
											break;
						case  2:	kvartalTxt = new String ("April kvartal");
											break;
						case  3:	kvartalTxt = new String ("Juli kvartal");
											break;
						case  4:	kvartalTxt = new String ("Oktober kvartal");
											break;
						default:	kvartalTxt = new String ("Fejl kvartal");
				}
			 	return (kvartalTxt);
		}

		public	String	getKvartalTxtAlternativ()		// med if-else
		{
				String kvartalTxt;
				if (this.getKvartal() == 1)
						kvartalTxt = new String ("Januar kvartal");
				else if (this.getKvartal() == 2)
						kvartalTxt = new String ("April kvartal");
				else if (this.getKvartal() == 3)
						kvartalTxt = new String ("Juli kvartal");
				else if (this.getKvartal() == 4)
						kvartalTxt = new String ("Oktober kvartal");
				else
						kvartalTxt = new String ("Fejl kvartal");
			 	return (kvartalTxt);
		}

		private	int	getSkudDage() 	// udregner skuddage i ret
		{
				int skudDage;														// Hjlpevariabel
				if ( (this.getAar()%4) == 0) 						// Test for muligt skudr
				{
						if ( (this.getAar()%100) == 0) 			// Test for rhundrede
						{
								if ( (this.getAar()%400) == 0) 	// rhundrede deligt med 4 ?
										skudDage = 1;
								else
									skudDage = 0;
			 			}
						else
								skudDage = 1;
				}
				else
					skudDage = 0;
				return (skudDage);
		}

		private	int		getMaxDag ()
		{
				int maxDag;
				switch (this.getMaaned())
				{
				 		case 1:
						case 3:
						case 5:
						case 7:
						case 8:
						case 10:
						case 12:	maxDag = 31;
											break;
						case 4:
						case 6:
						case 9:
						case 11:	maxDag = 30;
								 			break;
						case 2:		maxDag = 28 + this.getSkudDage();
								 			break;
						default:	maxDag = 0;
				}
				return (maxDag);	
		}

		public	void	calcNextDate ()
		{
			 	if (this.getDag() < this.getMaxDag())
						this.setDag(this.getDag()+1);
				else if (this.getMaaned() < 12)
				{
						this.setDag(1);
						this.setMaaned(this.getMaaned()+1);
				}
				else
				{
						this.setDag(1);
						this.setMaaned(1);
						this.setAar(this.getAar()+1);
				}
		}

		public	void	calcPrevDate ()
		{
			 	if (this.getDag() > 1)
						this.setDag(this.getDag()-1);
				else if (this.getMaaned() > 1)
				{
						this.setMaaned(this.getMaaned()-1);
						this.setDag(this.getMaxDag());
				}
				else
				{
						this.setAar(this.getAar()-1);
						this.setMaaned(12);
						this.setDag(this.getMaxDag());
				}
		}
		public	void	calcNewDate (int antalDage)
		{
				if (antalDage > 0)
				{
						while (antalDage > 0)
						{
								this.calcNextDate();
								antalDage = antalDage - 1;
						}
				}
				else if (antalDage < 0)
				{
						while (antalDage < 0)
						{
								this.calcPrevDate();
								antalDage = antalDage + 1;
						}
				}
		}

		public	int		getDagnr ()
		{
				int gemDatoen = this.datoen;		// gem datoen
				
				int dagnr = 1;
				
				while ( (this.getMaaned() > 1) || (this.getDag() > 1) ) 
				{
						this.calcPrevDate();
						dagnr = dagnr + 1;
				}
				this.datoen = gemDatoen;				// genetabler datoen
				return (dagnr);
		}

}